/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package interfacegrafica;

import static imagem.Imagem.verificaImagem;
import imagem.ImagemPgm;
import imagem.ImagemPpm;
import java.awt.Image;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author hugo
 */
public class JanelaPgm extends javax.swing.JFrame {

   private ImagemPgm pgm;
   
   public ImagemPgm getImagemPgm () {
       return pgm;
   }
   public void setImagemPgm (ImagemPgm pgm) {
       this.pgm = pgm;    
   }
   
   //Construtor
    public JanelaPgm(ImagemPgm pgm) {
        initComponents();
        setImagemPgm(pgm);
        
        txtDecifra.setVisible(false);
        
        
       try {
         pgm.abrirArquivo();
       } catch (FileNotFoundException ex) {
           Logger.getLogger(JanelaPgm.class.getName()).log(Level.SEVERE, null, ex);
       }
        
        pgm.pegaDados(pgm.lerLinhasCabecalho());
        pgm.pegaInicioMensagem();
              
        lblEndereco.setText(pgm.getEnderecoArquivo());
        
       try {
           lblImagem.setIcon(new ImageIcon(pgm.pegaPixels().getScaledInstance(550, 520, Image.SCALE_REPLICATE)));
       } catch (IOException ex) {
           Logger.getLogger(JanelaPgm.class.getName()).log(Level.SEVERE, null, ex);
       }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnGrupo = new javax.swing.ButtonGroup();
        lblArquivo = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        rbtnDecifra = new javax.swing.JRadioButton();
        rbtnNegativo = new javax.swing.JRadioButton();
        rbtnSharpen = new javax.swing.JRadioButton();
        rbtnBlur = new javax.swing.JRadioButton();
        btnAtivaFiltro = new javax.swing.JButton();
        btnAbrir = new javax.swing.JButton();
        lblImagem = new javax.swing.JLabel();
        lblEndereco = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtDecifra = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Imagem PGM");
        setResizable(false);

        lblArquivo.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        lblArquivo.setText("Local do arquivo:");
        lblArquivo.setBorder(new javax.swing.border.MatteBorder(null));

        jLabel1.setText("Mensagem Esteganografada");

        btnGrupo.add(rbtnDecifra);
        rbtnDecifra.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        rbtnDecifra.setText("Decifrar Mensagem");
        rbtnDecifra.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtnDecifraActionPerformed(evt);
            }
        });

        btnGrupo.add(rbtnNegativo);
        rbtnNegativo.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        rbtnNegativo.setText("Filtro negativo");
        rbtnNegativo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtnNegativoActionPerformed(evt);
            }
        });

        btnGrupo.add(rbtnSharpen);
        rbtnSharpen.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        rbtnSharpen.setText("Filtro Sharpen");
        rbtnSharpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtnSharpenActionPerformed(evt);
            }
        });

        btnGrupo.add(rbtnBlur);
        rbtnBlur.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        rbtnBlur.setText("Filtro Smooth");
        rbtnBlur.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtnBlurActionPerformed(evt);
            }
        });

        btnAtivaFiltro.setFont(new java.awt.Font("Dialog", 1, 16)); // NOI18N
        btnAtivaFiltro.setText("Ativar");
        btnAtivaFiltro.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAtivaFiltroActionPerformed(evt);
            }
        });

        btnAbrir.setText("Abrir");
        btnAbrir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAbrirActionPerformed(evt);
            }
        });

        lblImagem.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Imagem", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.TOP));

        lblEndereco.setBorder(new javax.swing.border.MatteBorder(null));

        txtDecifra.setColumns(20);
        txtDecifra.setRows(5);
        jScrollPane1.setViewportView(txtDecifra);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addComponent(btnAbrir, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(lblArquivo)
                .addGap(4, 4, 4)
                .addComponent(lblEndereco, javax.swing.GroupLayout.PREFERRED_SIZE, 369, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createSequentialGroup()
                .addGap(38, 38, 38)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(rbtnDecifra)
                    .addComponent(rbtnNegativo)
                    .addComponent(rbtnSharpen)
                    .addComponent(rbtnBlur)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(btnAtivaFiltro, javax.swing.GroupLayout.PREFERRED_SIZE, 112, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel1))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(8, 8, 8)
                        .addComponent(lblImagem, javax.swing.GroupLayout.PREFERRED_SIZE, 560, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(17, 17, 17)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnAbrir, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(16, 16, 16)
                        .addComponent(lblArquivo))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(13, 13, 13)
                        .addComponent(lblEndereco, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(22, 22, 22)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(84, 84, 84)
                        .addComponent(rbtnDecifra)
                        .addGap(4, 4, 4)
                        .addComponent(rbtnNegativo)
                        .addGap(4, 4, 4)
                        .addComponent(rbtnSharpen)
                        .addGap(4, 4, 4)
                        .addComponent(rbtnBlur)
                        .addGap(46, 46, 46)
                        .addComponent(btnAtivaFiltro, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(224, 224, 224)
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(lblImagem, javax.swing.GroupLayout.PREFERRED_SIZE, 530, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(20, 20, 20))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnAbrirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAbrirActionPerformed
        JFileChooser choose = new JFileChooser();
        choose.setFileFilter(new FileNameExtensionFilter(".ppm, .pgm", "ppm", "pgm"));
        choose.setAcceptAllFileFilterUsed(false);
        choose.showOpenDialog(this);

        try {
            File arquivo = choose.getSelectedFile();
            switch (verificaImagem(arquivo.getPath())) {
                case 1:
                    ImagemPgm pgmJanela = new ImagemPgm(arquivo.getPath());
                    JanelaPgm interfacePgm = new JanelaPgm(pgmJanela);
                    interfacePgm.setVisible(true);
                    dispose();
                    break;
                case 2:
                    ImagemPpm ppm = new ImagemPpm(arquivo.getPath());
                    JanelaPpm interfacePpm = new JanelaPpm(ppm);
                    interfacePpm.setVisible(true);
                    dispose();
                    break;
                default:
                    JOptionPane.showMessageDialog(null, "\nO tipo da imagem está incorreta.\nEscolha uma imagem válida.", "Arquivo inválido!", JOptionPane.ERROR_MESSAGE);
                    break;
            }
        } catch (NullPointerException npE) {
        } catch (IOException ex) {
            Logger.getLogger(PrimeiraTela.class.getName()).log(Level.SEVERE, null, ex);
        }    }//GEN-LAST:event_btnAbrirActionPerformed

    
    
    private void btnAtivaFiltroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAtivaFiltroActionPerformed
        String opcao = btnGrupo.getSelection().getActionCommand();
        
        if (opcao.equals("Decifra")) {
            getImagemPgm().pegaInicioMensagem();
            txtDecifra.setText(getImagemPgm().decifraImagem());
            txtDecifra.setVisible(true);

        } else if (opcao.equals("Filtro Negativo")) {
            try {
                lblImagem.setIcon(new ImageIcon(getImagemPgm().filtroNegativo().getScaledInstance(550, 520, Image.SCALE_REPLICATE)));
            } catch (IOException ex) {
                Logger.getLogger(JanelaPgm.class.getName()).log(Level.SEVERE, null, ex);
            }

        }
        else if (opcao.equals("Filtro Sharpen")) { 
            try {           
                lblImagem.setIcon(new ImageIcon(getImagemPgm().filtroSharpen().getScaledInstance(550, 520, Image.SCALE_REPLICATE)));
            } catch (IOException ex) {
                Logger.getLogger(JanelaPgm.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        else if (opcao.equals("Filtro Blur")) {
            try {            
                lblImagem.setIcon(new ImageIcon(getImagemPgm().filtroBlur().getScaledInstance(550, 520, Image.SCALE_REPLICATE)));
            } catch (IOException ex) {
                Logger.getLogger(JanelaPgm.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    
    }//GEN-LAST:event_btnAtivaFiltroActionPerformed

    private void rbtnDecifraActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtnDecifraActionPerformed
        rbtnDecifra.setActionCommand("Decifra");
    }//GEN-LAST:event_rbtnDecifraActionPerformed

    private void rbtnNegativoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtnNegativoActionPerformed
        rbtnNegativo.setActionCommand("Filtro Negativo");
    }//GEN-LAST:event_rbtnNegativoActionPerformed

    private void rbtnSharpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtnSharpenActionPerformed
        rbtnSharpen.setActionCommand("Filtro Sharpen");
    }//GEN-LAST:event_rbtnSharpenActionPerformed

    private void rbtnBlurActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtnBlurActionPerformed
        rbtnBlur.setActionCommand("Filtro Blur");
    }//GEN-LAST:event_rbtnBlurActionPerformed

    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAbrir;
    private javax.swing.JButton btnAtivaFiltro;
    private javax.swing.ButtonGroup btnGrupo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lblArquivo;
    private javax.swing.JLabel lblEndereco;
    private javax.swing.JLabel lblImagem;
    private javax.swing.JRadioButton rbtnBlur;
    private javax.swing.JRadioButton rbtnDecifra;
    private javax.swing.JRadioButton rbtnNegativo;
    private javax.swing.JRadioButton rbtnSharpen;
    private javax.swing.JTextArea txtDecifra;
    // End of variables declaration//GEN-END:variables
}
